#include <tos.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <falcon.h>
#include "asm.h"

long get_length(const char *fname);
int load(const char *fname, void *start, long length);
int save(const char *fname, void *start, long length);


int main()
{
	char m0[]="mono",m1[]="rgb",m2[]="vga",m3[]="rgb",lf[]={13,10,13,10,0},
       *mt[4],wiz_info[]="\\auto\\ndwizard.inf", *src, *dst, *tmp, *max;
	int f=0, mtype, x[4]={4,3,3,3};
	long length,length2;
	void *start,*start2;
	
	mt[0]=m0; mt[1]=m1;
	mt[2]=m2; mt[3]=m3;
	
	do
	{
		mtype=mon_type();	
		Cconws(ta[mtype]);
		
		/* Load ndwizard.inf */
		
		length=get_length(wiz_info);
		if (length!=0)
		{
			start=malloc(length+1);
			if (start!=NULL)
			{
				load(wiz_info,start,length);
			}
			else {
				f=1;
				break;
			}
		}
		else {
			f=1;
			break;
		}
		
		
		/* Find the right keyword */
		
		*((char *)start+length)=0;
		
		src=strstr(start,mt[mtype]);
		
		if (src==NULL)
		{
			f=1;
			break;
		}
		
		/* Source and destination paths */
		
		max=(char *)start+length;
		
		src+=x[mtype];
		while (*src==32)
		{
			src++;
			if (src>max) f=1;
		}
		if (f!=0) break;
		dst=src;
		while (*dst!=32)
		{
			dst++;
			if (dst>max) f=1;
		}
		if (f!=0) break;
		*dst++=0;
		while (*dst==32)
		{
			dst++;
			if (dst>max) f=1;
		}
		if (f!=0) break;
		tmp=dst;
		while (*tmp!=32 && *tmp!=13 && *tmp!=10 && *tmp!=0)
		{
			tmp++;
			if (tmp>max) f=1;
		}
		if (f!=0) break;
		*tmp=0;
		
		
		/* Load the right newdesk file */
		
		length2=get_length(src);
		if (length2!=0)
		{
			start2=malloc(length2);
			if (start2!=NULL)
			{
				load(src,start2,length2);
			}
			else {
				f=1;
				break;
			}
		}
		else {
			f=1;
			break;
		}
		
		/* Save to another path with another name */
		
		f=save(dst,start2,length2);
		break;
		
	} while (1);
	
	if (f!=0) Cconws("ERROR!");
	Cconws(lf);
	
	free(start);
	free(start2);
	return f;
}

/* Return the length in bytes or 0 on failure */
long get_length(const char *fname)
{
	int fildes;
	long length=0;
	
	fildes=open(fname,O_RDONLY);
	if (fildes>=0)
	{
		length=lseek(fildes,0L,SEEK_END);
		close(fildes);
	}
	
	return length;
}

int load(const char *fname, void *start, long length)
{
	int f=0,fildes;
	
	fildes=open(fname,O_RDONLY);
	if (fildes>=0)
	{
		read(fildes,start,length);
		close(fildes);
	}
	else f=1;
	
	return f;
}

int save(const char *fname, void *start, long length)
{
	int f=0;
	long handle,ret;
	
	handle=Fcreate(fname,0);
	if (handle>=0)
	{
		ret=Fwrite((int)handle,length,start);
		if (ret<0) f=1;
		else Fclose((int)handle);
	}
	else f=1;
	
	return f;
}